import { APIButton } from './widgets/ApiStatus.jsx'
import { DiskUsage } from './widgets/DiskUsage.jsx'
import { MessageWidget } from './widgets/MessageWidget.jsx'
import { PieChartWidget } from './widgets/PieChartWidget.jsx'
import { ScriptStatus } from './widgets/ScriptStatus.jsx'

const WidgetTypes = {
    pie: PieChartWidget,
    message: MessageWidget,
    'script-status': ScriptStatus,
    'disk-usage': DiskUsage,
    'api-button': APIButton,
}

export const Widget = ({ type, value }) => {
    const CustomWidget = WidgetTypes[type]

    return (
        <div class={'widget ' + type}>
            <CustomWidget {...value} />
        </div>
    )
}
