import { useRemoteState } from '../../util.jsx'
import { Icon } from '../Icon.jsx'
import { ToastMessage, useToasts } from '../Toasts.jsx'

export const ScriptStatus = ({ title, script }) => {
    const [showToast] = useToasts()
    const [output, err, refreshOutput] = useRemoteState(
        `/api/monitor/status?script=${encodeURIComponent(script)}`,
        ''
    )

    return (
        <>
            <div class="title">
                <div class="row">
                    <div class="row-group">{title}</div>
                    <div class="row-group">
                        <button
                            class="icon"
                            onClick={() => {
                                refreshOutput()
                                showToast(
                                    <ToastMessage icon="info">Aggiornato "{title}"</ToastMessage>
                                )
                            }}
                        >
                            <Icon name="refresh" />
                        </button>
                    </div>
                </div>
            </div>
            <div class="content">
                {err ? (
                    <p>Errore "{err}"</p>
                ) : (
                    <pre>
                        <code>{output}</code>
                    </pre>
                )}
            </div>
        </>
    )
}
