import { useEffect, useState } from 'preact/hooks'
import { ToastMessage, useToasts } from '../components/Toasts.jsx'

export const AdminPanel = () => {
    const [showToast] = useToasts()

    const [text, setText] = useState('')

    useEffect(() => {
        fetch('/api/dashboard-state')
            .then(res => res.json())
            .then(state => setText(JSON.stringify(state, null, 2)))
    }, [])

    const onSubmit = async e => {
        const formatted = JSON.stringify(JSON.parse(text), null, 2)

        const res = await fetch('/api/dashboard-state', {
            headers: { 'Content-Type': 'application/json' },
            method: 'POST',
            body: text,
        })

        if (!res.ok) {
            showToast(`Errore "${await res.text()}"`)
        }

        setText(formatted)

        showToast(<ToastMessage icon="info">Dashboard aggiornata</ToastMessage>)
    }

    return (
        <form>
            <div class="fill title">Dashboard State</div>
            <textarea
                class="fill mono"
                name="state"
                cols="80"
                rows="20"
                value={text}
                onInput={e => setText(e.target.value)}
            ></textarea>
            <div class="fill center">
                <button type="button" onClick={onSubmit}>
                    Update
                </button>
            </div>
        </form>
    )
}
