import { useEffect, useState } from 'preact/hooks'
import { Widget } from '../components/Widgets.jsx'

export const Dashboard = () => {
    const [widgets, setWidgets] = useState([])

    useEffect(() => {
        fetch('/api/dashboard-state')
            .then(res => res.json())
            .then(state => setWidgets(state.widgets))
    }, [])

    return (
        <div class="widgets">
            {widgets.map(w => (
                <Widget {...w} />
            ))}
        </div>
    )
}
